<template>
    <div id="app" :class="['app', { 'index-page': $route.path === '/' }]">
        <loader v-if="$loader"></loader>
        <component :is="currentLayout"></component>
    </div>
</template>

<script>
export default {
    name: 'app',
    components: {
        Loader: () => import('@/components/Loader'),
        DefaultLayout: () => import('src/layouts/default'),
        UploadLayout: () => import('src/layouts/upload'),
        Ois: () => import('@/pages/Ois')
    },
    computed: {
        currentLayout() {
            return (this.$route.meta.layout || 'default') + '-layout';
        },
        ...mapGetters('interface', ['$loader'])
    },
    async created() {
        await this.generateToken();
    },
    mounted() {
        this.setScreenProperties({ width: window.outerWidth, height: outerHeight });
        window.addEventListener('resize', e => {
            const { outerWidth, outerHeight } = e.target;
            this.setScreenProperties({ width: outerWidth, height: outerHeight });
        });
    },
    methods: {
        ...mapActions('information', ['setScreenProperties']),
        ...mapActions('account', ['checkAuthorized', 'generateToken'])
    }
};
</script>

<style lang="sass">
    @import '~assets/styles/index.sass';
</style>
